.TH "discover" "1" 
.SH "NAME" 
discover \(em hardware detection utility 
.SH "SYNOPSIS" 
.PP 
\fBdiscover\fR [DATA_OPTIONS]  [DISPLAY_OPTIONS]  [\-\-bus-summary]  [bus \&...]  
.PP 
\fBdiscover\fR [DATA_OPTIONS]  [DISPLAY_OPTIONS] \-\-type-summary  [type \&...]  
.PP 
\fBdiscover\fR [DATA_OPTIONS] \-\-data-path=\fIpath/to/data\fR \&...  [\-\-data-version=\fIversion\fR]  [\-\-normalize-whitespace]  [\-\-format=\fIformat string\fR]  [type | id \&...]  
.IP "DATA_OPTIONS" 10 
.RS 
.IP "   \(bu" 6 
\fB-d | \-\-disable-bus=\fIbus\fR\fP 
.IP "   \(bu" 6 
\fB-e | \-\-enable-bus=\fIbus\fR\fP 
.IP "   \(bu" 6 
\fB\-\-insert-url=\fIurl\fR\fP 
.IP "   \(bu" 6 
\fB\-\-append-url=\fIurl\fR\fP 
.IP "   \(bu" 6 
\fB-v | \-\-verbose\fP 
.RE 
.IP "DISPLAY_OPTIONS" 10 
.RS 
.IP "   \(bu" 6 
\fB\-\-model | \-\-no-model\fP 
.IP "   \(bu" 6 
\fB\-\-model-id | \-\-no-model-id\fP 
.IP "   \(bu" 6 
\fB\-\-vendor | \-\-no-vendor\fP 
.IP "   \(bu" 6 
\fB\-\-vendor-id | \-\-no-vendor-id\fP 
.RE 
.SH "Description" 
.PP 
\fBdiscover\fR provides an extensible hardware 
detection and reporting interface. Hardware information is stored in an 
XML data format and can be retrieved across the network. 
.PP 
Fundamental modes of operation: 
.IP "   \(bu" 6 
Display a list of hardware devices based on type of device or 
system bus on which the devices reside, via 
\fB\-\-type-summary\fP or 
\fB\-\-bus-summary\fP (the latter of which is the 
default behavior). 
 
.IP "   \(bu" 6 
Query specified data for attached hardware, via 
\fB\-\-data-path\fP. 
.SH "Options" 
.IP "\fB-h | \-\-help\fP" 10 
Display a simple help message. 
.IP "\fB-v | \-\-verbose\fP" 10 
Instruct the tool to provide feedback as it operates. This 
will affect the output as \fBdiscover\fR parses certain 
arguments, so this should appear early in the command line. 
.IP "\fB-V | \-\-version\fP" 10 
Display the tool name and version. 
.IP "\fB-b | \-\-bus-summary\fP" 10 
This is the default behavior: Display basic information 
regarding all devices on the appropriate buses. See 
\fI"Selecting Buses"\fR >. 
.IP "\fB-t | \-\-type-summary\fP" 10 
Summarize devices by class of hardware. Examples of valid 
device types include \fBbroadband\fP, 
\fBfixeddisk\fP, 
\fBdisplay\fP, and 
\fBnetwork\fP.  See \fI"Device Types"\fR >. 
.IP "\fB\-\-data-path=\fIpath/to/data\fR\fP" 10 
Query matching devices for detailed information. 
Device-specific data is stored in a hierarchical 
fashion, and the query argument comprises strings 
naming each level in that hierarchy. 
.IP "" 10 
Typically, the top-level component of the data 
path will be the ``\fIplatform\fP'' that will need 
the information, such as \fBlinux\fP or 
\fBxfree86\fP. For example, to retrieve 
the Linux kernel module name for a piece of hardware, 
the \fB\-\-data-path\fP argument would be 
\fBlinux/module/name\fP. 
.IP "" 10 
If multiple \fB\-\-data-path\fP           arguments are given and no format string (see 
\fB\-\-format\fP) is provided, only the last 
path is used. 
.IP "" 10 
See also the \fB\-\-data-version\fP           argument. 
.IP "\fB\-\-data-version=\fIversion\fR\fP" 10 
Specify a version string for the platform that 
will use the information specified by the argument to 
\fB\-\-data-path\fP. 
.IP "" 10 
This string must be in dotted-decimal notation in 
order to be matched against a range of values, and thus 
may be shorter than the real version. 
.IP "\fB\-\-format=\fIformat string\fR\fP" 10 
Dictate the output of the results of the queries 
specified by \fB\-\-data-path\fP arguments. 
This format string should follow 
\fBprintf(3)\fP specifications, although 
only \fB%s\fP and appropriate flags, 
precision, and width values are supported (or 
make sense); literal text and \fB%%\fP           can also be used.  The behavior when the string is 
poorly formatted is undefined.  See also 
\fB\-\-normalize-whitespace\fP. 
.IP "\fB-d | \-\-disable-bus=\fIbus\fR\fP" 10 
Use this option to override the list of 
buses to scan by default as defined in 
\fBdiscover.conf\fP. Use 
\fIall\fR as an argument to 
disable all buses; this is useful only if 
followed by 
\fB\-\-enable-bus\fP (or \fB-e\fP) 
arguments. 
.IP "\fB-e | \-\-enable-bus=\fIbus\fR\fP" 10 
Specify a bus to be scanned. 
.IP "\fB\-\-insert-url=\fIurl\fR\fP" 10 
Insert a URL at the head of 
the list of network resources to include in the search 
for hardware information.  Earlier data overrides 
later data; to override the local data 
sources, insert URLs into the list.  See also 
\fB\-\-append-url\fP. 
.IP "\fB\-\-append-url=\fIurl\fR\fP" 10 
Append a URL to the end of the 
list of network resources to search for 
hardware information. See also 
\fB\-\-insert-url\fP. 
.IP "\fB\-\-model\fP" 10 
Include the model description in summary 
information. This is enabled by default. 
.IP "\fB\-\-model-id\fP" 10 
Include the numeric model identifier in summary 
information. 
.IP "\fB\-\-no-model\fP" 10 
Do not include the model description in summary 
information. 
.IP "\fB\-\-no-model-id\fP" 10 
Do not include the numeric model identifier in summary 
information. This is the default. 
.IP "\fB\-\-vendor\fP" 10 
Include the vendor description in summary 
information. This is enabled by default. 
.IP "\fB\-\-vendor-id\fP" 10 
Include the numeric vendor identifier in summary 
information. 
.IP "\fB\-\-no-vendor\fP" 10 
Do not include the vendor description in summary 
information. 
.IP "\fB\-\-no-vendor-id\fP" 10 
Do not include the numeric vendor identifier in summary 
information. This is the default. 
.IP "\fB\-\-normalize-whitespace\fP" 10 
Consolidate whitespace in the results of a 
\fB\-\-data-path\fP query.  The default is not to do so, 
which faithfully reproduces all text in the raw XML data. 
.IP "" 10 
With this option enabled, leading and trailing whitespace 
is removed, and any consecutive internal whitespaces are 
compressed to a single space character. 
.SH "Selecting Buses" 
.PP 
\fBdiscover.conf\fP defines two lists of system 
buses: one to scan by default (used by the \fBdiscover\fR     command), and one never to scan (used by the \fBDiscover\fP library). 
.PP 
You can override and/or extend the list of default buses with 
\fB\-\-disable-bus\fP and \fB\-\-enable-bus\fP. 
The list of buses \fInot\fP to scan cannot be overridden 
without changing \fBdiscover.conf\fP, so that list 
should be used only for buses that may be dangerous to probe. 
.PP 
Both arguments take the string ``\fIall\fP'' as a 
value. 
.PP 
If a bus summary is being performed, which is indicated 
either by the presence of \fB\-\-bus-summary\fP or 
the absence of \fB\-\-type-summary\fP and 
\fB\-\-data-path\fP, any unattached arguments on the 
command line will be interpreted as the only buses to scan. 
This is equivalent to using \fB\-\-disable-bus 
all\fP before invoking \fB\-\-enable-bus\fP     for the buses of interest. 
.PP 
The following buses are currently supported by \fBDiscover\fP: 
 
.IP "   \(bu" 6 
\fBata\fP 
.IP "   \(bu" 6 
\fBpci\fP 
.IP "   \(bu" 6 
\fBpcmcia\fP 
.IP "   \(bu" 6 
\fBscsi\fP 
.IP "   \(bu" 6 
\fBusb\fP      
.SH "Device Types" 
.PP 
\fBDiscover\fP defines its own device types, to which the 
device types used by each bus are mapped.  \fBDiscover\fP     currently recognizes the following device types: 
 
.IP "   \(bu" 6 
\fBaudio\fP 
.IP "" 10 
A device capable of producing an analog or digital 
sound signal is an \fIaudio\fR device. 
Typically, any device commonly referred to as a 
``\fIsound card\fP'' is classified by \fBDiscover\fP as 
an audio device. 
.IP "   \(bu" 6 
\fBbridge\fP 
.IP "" 10 
A device that provides access to devices of a 
different type, commonly on a different bus, is a 
\fIbridge\fR device.  For instance, consumer 
PCI chipsets often feature a bridge to ATA (also 
known as IDE) devices. 
.IP "   \(bu" 6 
\fBbroadband\fP 
.IP "" 10 
An interface device to a computer communications 
network implemented on top of a technology not explicitly 
designed for that purpose is a \fIbroadband\fR     device.  Examples include ISDN terminal adapters as well 
as DSL and cable ``\fImodems\fP''; analog 
phone-line modems are not included in this classification 
(see ``\fImodem\fP'' below). 
.IP "   \(bu" 6 
\fBdisplay\fP 
.IP "" 10 
A device controlled by the host machine's CPU and 
capable of producing an analog or digital video signal 
for output purposes is a \fIdisplay\fR device. 
Typically, any device commonly referred to as a 
``\fIvideo card\fP'' is classified by \fBDiscover\fP as 
a display device. 
.IP "   \(bu" 6 
\fBfixeddisk\fP 
.IP "" 10 
A high-speed, fixed magnetic storage device such as 
a hard disk drive is a \fIfixeddisk\fR device. 
Removable media devices such as floppy disk drives, 
CD-ROM drives, magneto-optical devices, tape drives, and 
Compact Flash card readers are not included in this 
classification. 
.IP "   \(bu" 6 
\fBhumaninput\fP 
.IP "" 10 
A device that receives tactile input from a person 
for the purpose of directing a computer's activity is a 
\fIhumaninput\fR device.  Examples include 
keyboards, mice, trackballs, joysticks, gamepads, digital 
tablets manipulated with a stylus or finger, and so 
forth.  Input devices that rely upon non-tactile means of 
determining a person's intent, such as speech-recognition 
devices or cameras, are not included in this 
classification. 
.IP "   \(bu" 6 
\fBimaging\fP 
.IP "" 10 
A device that captures still images for input 
purposes is an \fIimaging\fR device.  Scanners 
and digital cameras are examples of imaging 
devices.  Motion-capture devices such as television tuner 
cards, webcams, and digital video cameras are not 
included in this classification. 
.IP "   \(bu" 6 
\fBmiscellaneous\fP 
.IP "" 10 
Any device that cannot logically be classified as 
another device type is a \fImiscellaneous\fR     device. 
.IP "   \(bu" 6 
\fBmodem\fP 
.IP "" 10 
An analog phone-line modulator/demodulator 
(modem) is classified by \fBDiscover\fP as a 
\fImodem\fR device.  No other kind of device is 
so classified. 
.IP "   \(bu" 6 
\fBnetwork\fP 
.IP "" 10 
An interface device to a conventional computer 
data communications network that does not require the use of a terminal 
adapter is a \fInetwork\fR device.  For example, 
Ethernet and Token Ring network interface cards are network 
devices.  Analog phone-line modems; terminal adapters 
for technologies such as ISDN and DSL; and ``\fIcable modems\fP''     are not ``\fInetwork\fP'' devices. 
.IP "   \(bu" 6 
\fBoptical\fP 
.IP "" 10 
An optical-technology storage device, often using 
read-only media, is an \fIoptical\fR device.  By 
far the most common examples of these devices are CD-ROM 
and DVD-ROM drives, including versions of these drives 
that can ``\fIburn\fP'' (write to) optical 
discs. 
.IP "   \(bu" 6 
\fBprinter\fP 
.IP "" 10 
A device that renders visual output in a permanent 
or semi-permanent manner to a physical medium is a 
\fIprinter\fR.  Typically, any device 
colloquially referred to as a ``\fIprinter\fP'' is 
also classified by \fBDiscover\fP as a 
printer. 
.IP "   \(bu" 6 
\fBremovabledisk\fP 
.IP "" 10 
Storage devices that feature removable media using 
just about any technology except that of magnetic tape, 
CD-ROM, and DVD-ROM drives are 
\fIremovabledisk\fR devices.  Examples include 
floppy disk drives, magneto-optical drives, and Compact 
Flash card readers. 
.IP "   \(bu" 6 
\fBtape\fP 
.IP "" 10 
A sequential-access mass storage device using 
magnetic tape is a \fItape\fR device.  Commonly 
used for archival and backup purposes, DAT drives are 
examples of tape devices. 
.IP "   \(bu" 6 
\fBvideo\fP 
.IP "" 10 
A device that produces a real-time digital video 
signal for input purposes is a \fIvideo\fR     device.  Webcams, digital video cameras, and television 
tuners are examples of video 
devices.  Note that still digital cameras with 
``\fImovie\fP'' capability are 
\fInot\fP considered video 
devices unless they can transmit the live video signal to 
the host in real time.      
.SH "Examples" 
.PP 
\fBScan the local buses\fR 
.PP 
.nf 
# discover 
Intel Corporation 82815 Chipset Host Bridge and Memory Controller Hub 
unknown unknown 
unknown unknown 
unknown unknown 
Intel Corporation 82815 Chipset IDE controller 
Intel Corporation 82815 Chipset USB (A) 
Intel Corporation 82815 System Management bus controller 
ATI Technologies, Inc. Rage 128 Pro GL [PF] 
3Com Corporation 3c905C-TX [Fast Etherlink] 
Ensoniq ES1371 [AudioPCI-97] 
unknown unknown 
.fi 
.PP 
\fBView PCI video cards\fR 
.PP 
.nf 
# discover \-v \-\-type-summary \-\-disable-bus all \-\-enable-bus pci display 
Disabled pci 
Disabled pcmcia 
Disabled scsi 
Disabled usb 
Enabled pci 
Loading XML data... pci Done 
Scanning buses... pci Done 
ATI Technologies, Inc. Rage 128 Pro GL [PF] 
.fi 
.PP 
\fBQuery for the driver module for 
XFree86 server version 4.2.0\fR 
.PP 
.nf 
# discover \-\-data-path=xfree86/server/device/driver \-\-data-version=4.2.0 display 
ati 
.fi 
.PP 
\fBGet model and vendor 
information by type\fR 
.PP 
.nf 
$ discover \-t \-\-no-model 
Intel Corporation 
NVIDIA Corporation 
3Com Corporation 
$ discover \-t \-\-no-vendor 
82815 System Management bus controller 
Vanta [NV6] 
3c905C-TX [Fast Etherlink] 
.fi 
.SH "Files" 
.IP "\fB/etc/discover.conf.d\fP" 10 
The directory containing configuration files that control  
the default behavior for both the \fBdiscover\fR tool and  
the \fBDiscover\fP library. 
 
.IP "\fB/discover/list.xml\fP" 10 
An XML file containing URLs with 
hardware information. This list can be extended with 
\fB\-\-append-url\fP and 
\fB\-\-extend-url\fP. 
 
.SH "Authors" 
.PP 
Josh Bressers, John R. Daily, and 
G. Branden Robinson developed the current implementation of 
\fBDiscover\fP for Progeny Linux Systems. 
.PP 
The Linux implementation of the system-dependent interfaces is 
derived from \fBdetect\fR, by MandrakeSoft SA. 
.SH "See Also" 
.PP 
discover.conf(5), discover-modprobe(8) 
.\" created by instant / docbook-to-man, Thu 31 Aug 2006, 11:05 
